#pragma once
#include <vector>
#include "gamebuilder.h"
#include "../context/gamecontext.h"

class CommonBuilder: public IGameBuilder {
public:
	virtual void create_context(float dynamic_objects_ratio) override {}
	virtual void create_state(IStateManager& state_manager, sf::VideoMode videomode, const std::string window_title) override{}
	virtual void set_all_to_state() override {}
	virtual GameState* get_game() override {}
private:
	float m_width;
	float m_height;
	float m_room_size;
	std::vector <std::vector<Room*>> m_rooms;
	GameContext m_context;
	GameState* m_game_state;
};

class SimpleBuilder : CommonBuilder {
	virtual void create_rooms() override {}
	virtual void set_rooms_sides() override {}
};
class ComplexBuilder : CommonBuilder {
	virtual void create_rooms() override {}
	virtual void set_rooms_sides() override {}
};